VERSION 6
BEGIN SCHEMATIC
    BEGIN ATTR DeviceFamilyName "spartan3"
        DELETE all:0
        EDITNAME all:0
        EDITTRAIT all:0
    END ATTR
    BEGIN NETLIST
        SIGNAL clk
        SIGNAL rst
        SIGNAL led(7:0)
        SIGNAL XLXN_4
        SIGNAL XLXN_5
        SIGNAL XLXN_6
        SIGNAL ps2ck
        SIGNAL lcd_e
        SIGNAL lcd_rw
        SIGNAL lcd_rs
        SIGNAL data(7:0)
        SIGNAL ps2dk
        PORT Input clk
        PORT Input rst
        PORT Output led(7:0)
        PORT BiDirectional ps2ck
        PORT Output lcd_e
        PORT Output lcd_rw
        PORT Output lcd_rs
        PORT Output data(7:0)
        PORT BiDirectional ps2dk
        BEGIN BLOCKDEF div_256
            TIMESTAMP 2006 4 21 13 15 29
            RECTANGLE N 64 -128 320 0 
            LINE N 64 -96 0 -96 
            LINE N 64 -32 0 -32 
            LINE N 320 -96 384 -96 
        END BLOCKDEF
        BEGIN BLOCKDEF div16
            TIMESTAMP 2006 4 21 13 15 25
            RECTANGLE N 64 -128 320 0 
            LINE N 64 -96 0 -96 
            LINE N 64 -32 0 -32 
            LINE N 320 -96 384 -96 
        END BLOCKDEF
        BEGIN BLOCKDEF lcd
            TIMESTAMP 2006 4 21 13 15 35
            RECTANGLE N 64 -256 320 0 
            LINE N 64 -224 0 -224 
            LINE N 64 -128 0 -128 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            LINE N 320 -224 384 -224 
            LINE N 320 -160 384 -160 
            LINE N 320 -96 384 -96 
            RECTANGLE N 320 -44 384 -20 
            LINE N 320 -32 384 -32 
        END BLOCKDEF
        BEGIN BLOCKDEF ps2_keyboard_interface
            TIMESTAMP 2006 4 21 13 15 42
            RECTANGLE N 64 -640 336 0 
            LINE N 64 -608 0 -608 
            LINE N 64 -464 0 -464 
            LINE N 64 -320 0 -320 
            LINE N 64 -176 0 -176 
            RECTANGLE N 0 -44 64 -20 
            LINE N 64 -32 0 -32 
            LINE N 336 -608 400 -608 
            LINE N 336 -544 400 -544 
            LINE N 336 -480 400 -480 
            LINE N 336 -416 400 -416 
            LINE N 336 -352 400 -352 
            LINE N 336 -288 400 -288 
            RECTANGLE N 336 -236 400 -212 
            LINE N 336 -224 400 -224 
            RECTANGLE N 336 -172 400 -148 
            LINE N 336 -160 400 -160 
            LINE N 336 -96 400 -96 
            LINE N 336 -32 400 -32 
        END BLOCKDEF
        BEGIN BLOCK XLXI_1 div_256
            PIN mclk clk
            PIN reset rst
            PIN clk XLXN_6
        END BLOCK
        BEGIN BLOCK XLXI_2 div16
            PIN clk clk
            PIN rst rst
            PIN clk_16 XLXN_5
        END BLOCK
        BEGIN BLOCK XLXI_3 lcd
            PIN clk XLXN_5
            PIN rst XLXN_4
            PIN data_in(7:0) led(7:0)
            PIN lcd_e lcd_e
            PIN lcd_rw lcd_rw
            PIN lcd_rs lcd_rs
            PIN data(7:0) data(7:0)
        END BLOCK
        BEGIN BLOCK XLXI_4 ps2_keyboard_interface
            PIN clk XLXN_6
            PIN reset rst
            PIN rx_read
            PIN tx_write
            PIN tx_data(7:0)
            PIN rx_extended
            PIN rx_released XLXN_4
            PIN rx_shift_key_on
            PIN rx_data_ready
            PIN tx_write_ack_o
            PIN tx_error_no_keyboard_ack
            PIN rx_scan_code(7:0)
            PIN rx_ascii(7:0) led(7:0)
            PIN ps2_clk ps2ck
            PIN ps2_data ps2dk
        END BLOCK
    END NETLIST
    BEGIN SHEET 1 3520 2720
        BEGIN INSTANCE XLXI_1 1104 960 R0
        END INSTANCE
        BEGIN INSTANCE XLXI_4 1632 1328 R0
        END INSTANCE
        BEGIN INSTANCE XLXI_3 2160 1600 R0
        END INSTANCE
        BEGIN INSTANCE XLXI_2 1104 1536 R0
        END INSTANCE
        BEGIN BRANCH clk
            WIRE 896 864 1088 864
            WIRE 1088 864 1104 864
            WIRE 1088 864 1088 1440
            WIRE 1088 1440 1104 1440
        END BRANCH
        BEGIN BRANCH rst
            WIRE 896 928 1072 928
            WIRE 1072 928 1104 928
            WIRE 1072 928 1072 1152
            WIRE 1072 1152 1072 1504
            WIRE 1072 1504 1104 1504
            WIRE 1072 1152 1616 1152
            WIRE 1616 864 1616 1152
            WIRE 1616 864 1632 864
        END BRANCH
        BEGIN BRANCH led(7:0)
            WIRE 2032 1168 2096 1168
            WIRE 2096 1168 2096 1568
            WIRE 2096 1568 2160 1568
            WIRE 2096 1168 2336 1168
        END BRANCH
        BEGIN BRANCH XLXN_4
            WIRE 2032 784 2048 784
            WIRE 2048 784 2112 784
            WIRE 2112 784 2112 1472
            WIRE 2112 1472 2160 1472
        END BRANCH
        BEGIN BRANCH XLXN_5
            WIRE 1488 1440 1504 1440
            WIRE 1504 1440 1824 1440
            WIRE 1824 1376 1824 1440
            WIRE 1824 1376 2160 1376
        END BRANCH
        BEGIN BRANCH XLXN_6
            WIRE 1488 864 1552 864
            WIRE 1552 720 1552 864
            WIRE 1552 720 1632 720
        END BRANCH
        BEGIN BRANCH ps2ck
            WIRE 2032 1232 2336 1232
        END BRANCH
        BEGIN BRANCH lcd_e
            WIRE 2544 1376 2624 1376
            WIRE 2624 1376 2640 1376
        END BRANCH
        BEGIN BRANCH lcd_rw
            WIRE 2544 1440 2624 1440
            WIRE 2624 1440 2640 1440
        END BRANCH
        BEGIN BRANCH lcd_rs
            WIRE 2544 1504 2624 1504
            WIRE 2624 1504 2640 1504
        END BRANCH
        BEGIN BRANCH data(7:0)
            WIRE 2544 1568 2624 1568
            WIRE 2624 1568 2640 1568
        END BRANCH
        IOMARKER 2336 1168 led(7:0) R0 28
        IOMARKER 2336 1232 ps2ck R0 28
        IOMARKER 2640 1376 lcd_e R0 28
        IOMARKER 2640 1440 lcd_rw R0 28
        IOMARKER 2640 1504 lcd_rs R0 28
        IOMARKER 2640 1568 data(7:0) R0 28
        IOMARKER 896 928 rst R180 28
        IOMARKER 896 864 clk R180 28
        IOMARKER 2320 1056 ps2dk R0 28
        BEGIN BRANCH ps2dk
            WIRE 2032 1296 2176 1296
            WIRE 2176 1056 2176 1296
            WIRE 2176 1056 2320 1056
        END BRANCH
    END SHEET
END SCHEMATIC
