`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    16:28:16 06/08/07
// Design Name:    
// Module Name:    SlaveFIFO
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// ʵ첽FIFOĶд, 첿ʽͨIFCONFIG.3=1õ,IFCONFIG.3=0ʱΪ
// ͬʽ
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module SlaveFIFO(clk, rst, FLAGA, FLAGB, FIFODATA, 
                    SLOE, SLRD, SLWR,FIFOADR,SRAM_CE, SRAM_WE, SRAM_OE, SRAM_Addr, 
                    SRAM_IO,SRAM_BE,led,test1,test2);
    input clk; //ʱ40M
    input rst;
	//FLAGS,Ĭǵ͵ƽЧ
    input FLAGA; //EP2EF,EP2Ŀձ־
    input FLAGB; //EP6FF,EP6־
    inout [7:0] FIFODATA; 
    output SLOE; //ʹ,Ĭ,͵ƽЧ,ԿFIFOPINPOLARĴı.
    output SLRD; //ƶȡ
    output SLWR; //д,첽ģʽ,ؽд
	output [1:0] FIFOADR; //ѡEP2,EP4,EP6EP8еһFIFOFD
    output SRAM_CE;
    output SRAM_WE;
    output SRAM_OE;
    output [17:0] SRAM_Addr;
	output [1:0] SRAM_BE;
    inout [7:0] SRAM_IO;
    output led;
	reg led;

	output test1,test2;

    // regs for output
	reg [1:0] wr_fifo_addr;
	reg [1:0] rd_fifo_addr;
	reg SLOE,SLRD,SLWR;
	reg SRAM_CE;
	reg SRAM_WE;
	// regs for input
	reg flaga,flagb;

	// internal regs
	reg [7:0] FromFIFO;
	reg [7:0] ToFIFO;
	reg [17:0] Sram_Waddr;
	reg [17:0] Sram_Raddr;
	reg [6:0] RD_CS,RD_NS;
    reg [4:0] WR_CS,WR_NS;	
	reg ReadSram;
	reg WriteSram;
	reg [1:0] slwr_hcnt;
//	reg [1:0] slrd_hcnt;
	reg rd_temp,wr_temp;
	reg pc_write_end;

	parameter   SLWR_H = 2'b11;  //3ʱ,ʱΪ50M,SLWRߵƽٳ70ns
	parameter   SLRD_H = 2'b10;  //2ʱ,ʱΪ50M,SLRDߵƽٳ50ns


	parameter	WR_IDLE			= 5'b00000,
				WADDR_SET		= 5'b00001,
				SLWR_LOW		= 5'b00010,
				DATA_WRITE		= 5'b00100,
				SLWR_HIGH		= 5'b01000,
				WR_HALT			= 5'b10000;

	parameter	RD_IDLE			= 7'b0000000,
				RADDR_SET		= 7'b0000001, 
				SLOE_LOW		= 7'b0000010,
				SLRD_LOW		= 7'b0000100,
				DATA_READ		= 7'b0001000,
				WRITE_SRAM		= 7'b0010000,
				SLRD_HIGH		= 7'b0100000,
				RD_HALT			= 7'b1000000;

	
	assign test1=FLAGA;
	assign test2=FLAGB;
	assign SRAM_BE[1:0] = 2'b10;

	always @ (posedge clk)
	begin
		if(!rst)
		begin
			flaga<=0;
			flagb<=0;
	    end
		else
		begin
			flaga<=FLAGA;
			flagb<=FLAGB;
		end	
	end	
/********************Slave FIFOд״̬******************/
	/****sequential*******/
	always @ (posedge clk or negedge rst)
	begin
		if(~rst)
			WR_CS<=WR_IDLE;
		else 
			WR_CS<=WR_NS;
	end

	always @ (WR_CS or flagb or  Sram_Raddr or slwr_hcnt)
	begin
		case(WR_CS)
			WR_IDLE:
			begin
				if(flagb==1&&pc_write_end==1) //EP6,SRAMѾд,ʼFIFOд
					WR_NS=WADDR_SET;
				else
					WR_NS=WR_IDLE;
			end
			WADDR_SET: //wr_fifo_addr
			begin
				WR_NS=SLWR_LOW;
			end
			SLWR_LOW:
			begin
				WR_NS=DATA_WRITE;
			end
			DATA_WRITE: //SRAMȡݷ
			begin
				WR_NS=SLWR_HIGH;
			end
			SLWR_HIGH: //SLWRߵƽĸʱ
			begin
				if(slwr_hcnt==SLWR_H)
				begin
//					if(&Sram_Raddr[4:0]) //for test
					if(&Sram_Raddr[15:0])  //ֻȡ256*256
			//		if(&Sram_Raddr)  //ȡ1024*1024
						WR_NS=WR_HALT;
					else
					begin
						if(flagb==1)
							WR_NS=SLWR_LOW;
						else
							WR_NS=SLWR_HIGH;
					end
				end
				else
					WR_NS=SLWR_HIGH;
			end
			WR_HALT:
				WR_NS=WR_HALT;
			default:
				WR_NS=WR_IDLE;
		endcase	
	end
	/*******state machine output******/
	always @ (posedge clk or negedge rst)
	begin
		if(~rst)
		begin
			ToFIFO<=8'b0;
			SLWR<=1;
			Sram_Raddr[17:0]<=18'b0;
			wr_fifo_addr[1:0]<=2'b00;
			slwr_hcnt<=0;
			wr_temp<=0;
			ReadSram<=0;
		end
		else
		begin
			case(WR_NS)
				WR_IDLE:
				begin
					ToFIFO<=8'b0;
					SLWR<=1;
					Sram_Raddr[17:0]<=18'b0;
					ReadSram<=0;
					wr_fifo_addr[1:0]<=2'b00;
					slwr_hcnt<=0;
					wr_temp<=0;
				end
				WADDR_SET: //EP6
				begin
					wr_fifo_addr[1:0]<=2'b10;
					slwr_hcnt<=0;
					ReadSram<=1;
				end
				SLWR_LOW: 
				begin
					SLWR<=0;
					slwr_hcnt<=0;
					if(wr_temp)
						Sram_Raddr<=Sram_Raddr+1;
					else
						wr_temp<=1;
				end
				DATA_WRITE:   //SRAMȡݷ,ȴSLWRص,дFIFO
				begin
					ToFIFO[7:0]<=SRAM_IO[7:0]; 
				end
				SLWR_HIGH: //SLWRߵƽҪĸʱ
				begin
					SLWR<=1;
					slwr_hcnt<=slwr_hcnt+1;	
				end
				WR_HALT:
				begin
					ToFIFO<=8'b0;
					SLWR<=1;
					Sram_Raddr[17:0]<=18'b0;
					wr_fifo_addr[1:0]<=2'b00;
					slwr_hcnt<=0;
					ReadSram<=0;
				end
				default:
				begin
					ToFIFO<=8'b0;
					SLWR<=1;
					Sram_Raddr[17:0]<=18'b0;
					wr_fifo_addr[1:0]<=2'b00;
					slwr_hcnt<=0;
					ReadSram<=0;
				end
			endcase	
		end
	end	


/*****************Slave FIFO״̬*****************/
	/****sequential*******/
	always @ (posedge clk or negedge rst)
	begin
		if(~rst)
			RD_CS<=RD_IDLE;
		else
			RD_CS<=RD_NS;
	end
    /******combination***/
	always @ (RD_CS or flaga /*or slrd_hcnt*/ or Sram_Waddr)
	begin
		case(RD_CS)
			RD_IDLE:
			begin
				if(flaga==1) //EP2ǿ,ʼEP2Ļȡ
					RD_NS=RADDR_SET;
				else
					RD_NS=RD_IDLE;
			end
			RADDR_SET:  //fifo_adrѡ˿FD
			begin
				RD_NS=SLOE_LOW;
			end
			SLOE_LOW: //SLOE
			begin
				RD_NS=SLRD_LOW;
			end
			SLRD_LOW: //SLRD
			begin
				RD_NS=DATA_READ;
			end
			DATA_READ: //߶ȡдSRAM
			begin
				RD_NS=WRITE_SRAM;
			end
			WRITE_SRAM:
			begin
				RD_NS=SLRD_HIGH;
			end
			SLRD_HIGH: //SLRDߵƽٳ1ʱ
			begin
				if(&Sram_Waddr[15:0]) //ֻȡ256*256
			//	if(&Sram_Waddr[4:0])  //for test
		//		if(&Sram_Waddr)  //ȡ1024*1024
					RD_NS=RD_HALT;
				else
				begin
					if(flaga==1)
						RD_NS=SLRD_LOW;
					else
						RD_NS=SLRD_HIGH;
				end
			end
			RD_HALT:
				RD_NS=RD_HALT;
			default:
				RD_NS=RD_IDLE;
		endcase	
	end
	/*******state machine output******/
	always @ (posedge clk or negedge rst)
	begin
		if(~rst)
		begin
			FromFIFO<=8'b0;
			SLOE<=1;
			SLRD<=1;
			Sram_Waddr[17:0]<=18'b0;
			SRAM_WE<=1;
			rd_fifo_addr[1:0]<=2'b00;
			WriteSram<=0;
	//		slrd_hcnt<=0;
			rd_temp<=0;
			pc_write_end<=0;
			led<=0;
		end
		else
		begin
			case(RD_NS)
				RD_IDLE:
				begin
					FromFIFO<=8'b0;
					SLOE<=1;
					SLRD<=1;
					Sram_Waddr[17:0]<=18'b0;
					SRAM_WE<=1;
					rd_fifo_addr[1:0]<=2'b00;
					WriteSram<=0;
		//			slrd_hcnt<=0;
					rd_temp<=0;
				end
				RADDR_SET://EP2
				begin
					rd_fifo_addr[1:0]<=2'b00;
					SLOE<=1;
					SLRD<=1;
					WriteSram<=1; //ߵƽʱSRAMд
				end
				SLOE_LOW://SLOE
				begin
					SLOE<=0;
					SLRD<=1;
				end
				SLRD_LOW: //SLRD
				begin
					SLRD<=0;
		//			slrd_hcnt<=0;
					if(rd_temp)
						Sram_Waddr<=Sram_Waddr+1;
					else
						rd_temp<=1;
				end
				DATA_READ:  //϶ȡ,дSRAM
				begin
					FromFIFO[7:0]<=FIFODATA[7:0];
				end
				WRITE_SRAM:
				begin
					SLRD<=1;
					SRAM_WE<=0;
				end
				SLRD_HIGH:  //SLRDߵƽҪʱ
				begin
					SLRD<=1;
					SRAM_WE<=1;
	//				slrd_hcnt<=slrd_hcnt+1;
				end
				RD_HALT:
				begin
					WriteSram<=0;
					Sram_Waddr[17:0]<=18'b0;
					SLOE<=1;
					SLRD<=1;
					pc_write_end<=1;
					led<=1;
				end
				default:
				begin
					FromFIFO<=8'b0;
					SLOE<=1;
					SLRD<=1;
					Sram_Waddr[17:0]<=18'b0;
					rd_fifo_addr[1:0]<=2'b00;
					WriteSram<=0;
				end
			endcase	
		end
	end

	always @ (posedge clk or negedge rst)
	begin
		if(!rst)
			SRAM_CE<=1;
		else
			SRAM_CE<=0;
	end
/*
	always @ (posedge clk or negedge rst)
	begin
		if(~rst)
			SLCS<=1;
		else
			SLCS<=0;
	end*/

//	assign SRAM_WE=WriteSram?1'b0:1'b1;
	assign SRAM_OE=ReadSram?1'b0:1'b1;
	assign SRAM_IO[7:0]=WriteSram?FromFIFO[7:0]:8'bz;
	assign FIFODATA[7:0]=ReadSram?ToFIFO[7:0]:8'bz;
	assign FIFOADR[1:0]=ReadSram?wr_fifo_addr:rd_fifo_addr;
	assign SRAM_Addr[17:0]=ReadSram?Sram_Raddr[17:0]:Sram_Waddr[17:0];
//    assign led=FLAGA;

endmodule
