`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    16:28:16 07/11/15
// Design Name:    
// Module Name:   slavefifo_wr 
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// ʵ첽FIFOд, 첿ʽͨIFCONFIG.3=1õ,IFCONFIG.3=0ʱΪ
// ͬʽ
// ģʵ:ϵͳϵ縴λ,ֱFPGAд
// FIFOĻ,PCȡ,֤slave fifoдʱ
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module slavefifo_wr(clk, rst,FLAGB,FIFODATA, SLWR,FIFOADR, led);

    input clk; //ʱ40M
    input rst;
	//FLAGS,Ĭǵ͵ƽЧ
    input FLAGB; //EP6FF,EP6־
    inout [7:0] FIFODATA; 
    output SLWR; //д,첽ģʽ,ؽд
	output [1:0] FIFOADR; //ѡEP2,EP4,EP6EP8еһFIFOFD
   
    output led;
    // regs for output
	reg [1:0] FIFOADR;
	reg SLWR;
	// regs for input
	reg flagb;

	// internal regs
	reg [7:0] ToFIFO;
	reg [3:0] CS,NS;
	reg [1:0] slwr_hcnt;
	reg [19:0] count;
	reg temp;
	reg led;

	parameter   SLWR_H = 2'b11;  //3ʱ,ʱΪ50M,SLWRߵƽٳ70ns

	parameter	IDLE			= 4'b0000,
				WADDR_SET		= 4'b0001,
				SLWR_LOW		= 4'b0010,
				DATA_WRITE		= 4'b0100,
				SLWR_HIGH		= 4'b1000;

	always @ (posedge clk or negedge rst)
	begin
		if(!rst)
			flagb<=0;
		else
			flagb<=FLAGB;
	end	
	/****sequential*******/
	always @ (posedge clk or negedge rst)
	begin
		if(~rst)
			CS<=IDLE;
		else 
			CS<=NS;
	end
    /******combination***/
	always @ (CS or flagb or  count or slwr_hcnt)
	begin
		case(CS)
			IDLE:
			begin
				if(flagb==1) //EP6ʼFIFOд
					NS=WADDR_SET;
				else
					NS=IDLE;
			end
			WADDR_SET: //FIFOADR
			begin
				NS=SLWR_LOW;
			end
			SLWR_LOW:
			begin
				NS=DATA_WRITE;
			end
			DATA_WRITE: //ӽݷ,дFIFO
			begin
				NS=SLWR_HIGH;
			end
			SLWR_HIGH: //SLWRߵƽĸʱ
			begin
				if(slwr_hcnt==SLWR_H)
				begin
					if(&count[19:0]) //for test
						NS=IDLE;
					else
					begin
						if(flagb==1)
							NS=SLWR_LOW;
						else
							NS=SLWR_HIGH;
					end
				end
				else
					NS=SLWR_HIGH;
			end
			default:
				NS=IDLE;
		endcase	
	end
	/*******state machine output******/
	always @ (posedge clk or negedge rst)
	begin
		if(~rst)
		begin
			ToFIFO<=8'b0;
			SLWR<=1;
			FIFOADR[1:0]<=2'b00;
			slwr_hcnt<=0;
			temp<=0;
			count<=20'b0;
			led<=1;
		end
		else 
		begin
			case(NS)
				IDLE:
				begin
					ToFIFO<=8'b0;
					SLWR<=1;
					FIFOADR[1:0]<=2'b00;
					slwr_hcnt<=0;
					count<=0;
					temp<=0;
					led<=~led;
				end
				WADDR_SET: //EP6
				begin
					FIFOADR[1:0]<=2'b10;
					slwr_hcnt<=0;
				end
				SLWR_LOW: 
				begin
					SLWR<=0;
					slwr_hcnt<=0;
					if(temp)
						count<=count+1;
					else
					begin
						temp<=1;
						count<=0;
					end
				end
				DATA_WRITE:   //SRAMȡݷ,ȴSLWRص,дFIFO
				begin
					ToFIFO[7:0]<=count[7:0]; 
				end
				SLWR_HIGH: //SLWRߵƽҪĸʱ
				begin
					SLWR<=1;
					slwr_hcnt<=slwr_hcnt+1;	
				end
				default:
				begin
					ToFIFO<=8'b0;
					SLWR<=1;
					FIFOADR[1:0]<=2'b00;
					slwr_hcnt<=0;
					temp<=0;
					count<=0;
				end
			endcase	
		end
	end	

	assign FIFODATA[7:0]=flagb?ToFIFO[7:0]:8'bz;

endmodule

