`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    00:34:53 11/28/07
// Design Name:    
// Module Name:    top_slave_fifo
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module top_slave_fifo(clk50,rst,usb_reset,FLAGA,FLAGB,FIFODATA,FIFOADR,SLRD,SLWR,SLOE,
					  SRAM_CE,SRAM_WE,SRAM_OE,SRAM_Addr,SRAM_IO,FLASH_CE,FLASH_OE,FLASH_WE,
					  SDRAM_CE,SDRAM_CAS,SDRAM_RAS,SDRAM_WE,SRAM_BE,led);
	
	input clk50,rst;
	//EZ-USB signals
	input FLAGA,FLAGB;
	output SLRD,SLWR,SLOE;
	output [1:0] FIFOADR;
	output usb_reset;
	inout [7:0] FIFODATA;

	//SRAM signals
	output SRAM_CE,SRAM_OE,SRAM_WE;
	inout [7:0] SRAM_IO;
	output [1:0] SRAM_BE;
	output [17:0] SRAM_Addr;

	output FLASH_CE,FLASH_OE,FLASH_WE;
	output SDRAM_CE,SDRAM_CAS,SDRAM_RAS,SDRAM_WE;
	output led;

	wire clk40;
	
	assign FLASH_WE = 1;
	assign FLASH_OE = 1;
	assign FLASH_CE = 1;
	assign SDRAM_RAS = 1;
	assign SDRAM_CAS = 1;
	assign SDRAM_CE = 1;
	assign SDRAM_WE = 1;
	assign usb_reset = 1;
				  
	gen_clk40 gen_clk40(
		.CLKIN_IN(clk50), 
        .RST_IN(~rst), 
        .CLKFX_OUT(clk40), 
        .CLKIN_IBUFG_OUT(), 
        .CLK0_OUT(), 
        .LOCKED_OUT()
	);

	SlaveFIFO slave_fifo(
		.clk(clk40), 
		.rst(rst),
		.FLAGA(FLAGA),
		.FLAGB(FLAGB),
		.FIFODATA(FIFODATA),
        .SLOE(SLOE), 
		.SLRD(SLRD),
		.SLWR(SLWR),
		.FIFOADR(FIFOADR),
		.SRAM_CE(SRAM_CE),
		.SRAM_WE(SRAM_WE),
		.SRAM_OE(SRAM_OE),
		.SRAM_Addr(SRAM_Addr),
		.SRAM_IO(SRAM_IO),
		.SRAM_BE(SRAM_BE),
		.led(led),
		.test1(),
		.test2()
	);



endmodule
