library verilog;
use verilog.vl_types.all;
entity slavefifo is
    generic(
        slwr_h          : integer := 3;
        slrd_h          : integer := 2;
        wr_idle         : integer := 0;
        waddr_set       : integer := 1;
        slwr_low        : integer := 2;
        data_write      : integer := 4;
        slwr_high       : integer := 8;
        wr_halt         : integer := 16;
        rd_idle         : integer := 0;
        raddr_set       : integer := 1;
        sloe_low        : integer := 2;
        slrd_low        : integer := 4;
        data_read       : integer := 8;
        write_sram      : integer := 16;
        slrd_high       : integer := 32;
        rd_halt         : integer := 64
    );
    port(
        clk             : in     vl_logic;
        rst             : in     vl_logic;
        flaga           : in     vl_logic;
        flagb           : in     vl_logic;
        fifodata        : inout  vl_logic_vector(7 downto 0);
        sloe            : out    vl_logic;
        slrd            : out    vl_logic;
        slwr            : out    vl_logic;
        fifoadr         : out    vl_logic_vector(1 downto 0);
        sram_ce         : out    vl_logic;
        sram_we         : out    vl_logic;
        sram_oe         : out    vl_logic;
        sram_addr       : out    vl_logic_vector(17 downto 0);
        sram_io         : inout  vl_logic_vector(7 downto 0);
        sram_be         : out    vl_logic_vector(1 downto 0);
        led             : out    vl_logic;
        test1           : out    vl_logic;
        test2           : out    vl_logic
    );
end slavefifo;
