//-----------------------------------------------------------------------------
// Copyright (c) 1999-2005 Xilinx Inc.  All rights reserved.
//-----------------------------------------------------------------------------
// Title      : ILA Core Xilinx XST Usage Example
// Project    : ChipScope
//-----------------------------------------------------------------------------
// File       : vio_xst_example.v
// Company    : Xilinx Inc.
// Created    : 2002/03/27
//-----------------------------------------------------------------------------
// Description: Example of how to instantiate the ILA core in a Verilog 
//              design for use with the Xilinx XST synthesis tool.
//-----------------------------------------------------------------------------

module vio_xst_example
  (
  );


  //-----------------------------------------------------------------
  //
  //  ILA Core wire declarations
  //
  //-----------------------------------------------------------------
  wire [35:0] control;
  wire clk;
  wire [15:0] data;
  wire [7:0] trig0;


  //-----------------------------------------------------------------
  //
  //  ILA core instance
  //
  //-----------------------------------------------------------------
  vio i_vio
    (
      .control(control),
      .clk(clk),
      .data(data),
      .trig0(trig0)
    );


endmodule


//-------------------------------------------------------------------
//
//  ILA core module declaration
//
//-------------------------------------------------------------------
module vio
  (
    control,
    clk,
    data,
    trig0
  );
  input [35:0] control;
  input clk;
  input [15:0] data;
  input [7:0] trig0;
endmodule

