////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 1995-2003 Xilinx, Inc.
// All Right Reserved.
////////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /    Vendor: Xilinx 
// \   \   \/     Version : 7.1i
//  \   \         Application : ISE Foundation
//  /   /         Filename : test.tfw
// /___/   /\     Timestamp : Wed Nov 01 10:33:42 2006
// \   \  /  \ 
//  \___\/\___\ 
//
//Command: 
//Design Name: test
//Device: Xilinx
//
`timescale 1ns/1ps

module test;
    reg clk = 1'b0;
    reg rst = 1'b0;
    wire clkout_0;
    wire clkout_1;

    parameter PERIOD = 20;
    parameter real DUTY_CYCLE = 0.5;
    parameter OFFSET = 0;

    initial    // Clock process for clk
    begin
        #OFFSET;
        forever
        begin
            clk = 1'b0;
            #(PERIOD-(PERIOD*DUTY_CYCLE)) clk = 1'b1;
            #(PERIOD*DUTY_CYCLE);
        end
    end

    top UUT (
        .clk(clk),
        .rst(rst),
        .clkout_0(clkout_0),
        .clkout_1(clkout_1));

        integer TX_ERROR = 0;
        
        initial begin  // Open the results file...
            #1020 // Final time:  1020 ns
            if (TX_ERROR == 0) begin
                $display("No errors or warnings.");
                end else begin
                    $display("%d errors found in simulation.", TX_ERROR);
                    end
                    $stop;
                end

                initial begin
                    // -------------  Current Time:  7ns
                    #7;
                    rst = 1'b1;
                    // -------------------------------------
                    // -------------  Current Time:  13ns
                    #6;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  27ns
                    #14;
                    rst = 1'b0;
                    // -------------------------------------
                    // -------------  Current Time:  233ns
                    #206;
                    CHECK_clkout_0(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  253ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  273ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  293ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  313ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  333ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  353ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  373ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  393ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  413ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  433ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  453ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  473ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  493ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  513ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  533ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  553ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  573ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  593ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  613ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  633ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  653ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  673ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  693ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  713ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  733ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  753ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  773ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  793ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  813ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  833ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  853ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  873ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  893ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  913ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  933ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  953ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                    // -------------  Current Time:  973ns
                    #20;
                    CHECK_clkout_0(1'b0);
                    CHECK_clkout_1(1'b1);
                    // -------------------------------------
                    // -------------  Current Time:  993ns
                    #20;
                    CHECK_clkout_0(1'b1);
                    CHECK_clkout_1(1'b0);
                    // -------------------------------------
                end

                task CHECK_clkout_0;
                    input NEXT_clkout_0;

                    #0 begin
                        if (NEXT_clkout_0 !== clkout_0) begin
                            $display("Error at time=%dns clkout_0=%b, expected=%b", $time, clkout_0, NEXT_clkout_0);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_clkout_1;
                    input NEXT_clkout_1;

                    #0 begin
                        if (NEXT_clkout_1 !== clkout_1) begin
                            $display("Error at time=%dns clkout_1=%b, expected=%b", $time, clkout_1, NEXT_clkout_1);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask

            endmodule

