////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 1995-2003 Xilinx, Inc.
// All Right Reserved.
////////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /    Vendor: Xilinx 
// \   \   \/     Version : 7.1i
//  \   \         Application : ISE Foundation
//  /   /         Filename : test.tfw
// /___/   /\     Timestamp : Mon Oct 02 09:52:07 2006
// \   \  /  \ 
//  \___\/\___\ 
//
//Command: 
//Design Name: test
//Device: Xilinx
//
`timescale 1ns/1ps

module test;
    reg clk = 1'b0;
    reg rst = 1'b1;
    reg sw0 = 1'b0;
    reg sw1 = 1'b0;
    reg sw2 = 1'b0;
    reg sw3 = 1'b0;
    wire led0;
    wire led1;
    wire led2;
    wire led3;
    wire led4;
    wire led5;
    wire led6;
    wire led7;

    parameter PERIOD = 100;
    parameter real DUTY_CYCLE = 0.5;
    parameter OFFSET = 100;

    initial    // Clock process for clk
    begin
        #OFFSET;
        forever
        begin
            clk = 1'b0;
            #(PERIOD-(PERIOD*DUTY_CYCLE)) clk = 1'b1;
            #(PERIOD*DUTY_CYCLE);
        end
    end

    sw_led UUT (
        .clk(clk),
        .rst(rst),
        .sw0(sw0),
        .sw1(sw1),
        .sw2(sw2),
        .sw3(sw3),
        .led0(led0),
        .led1(led1),
        .led2(led2),
        .led3(led3),
        .led4(led4),
        .led5(led5),
        .led6(led6),
        .led7(led7));

        integer TX_ERROR = 0;
        
        initial begin  // Open the results file...
            #1600 // Final time:  1600 ns
            if (TX_ERROR == 0) begin
                $display("No errors or warnings.");
                end else begin
                    $display("%d errors found in simulation.", TX_ERROR);
                    end
                    $stop;
                end

                initial begin
                    // -------------  Current Time:  140ns
                    #140;
                    rst = 1'b0;
                    // -------------------------------------
                    // -------------  Current Time:  240ns
                    #100;
                    rst = 1'b1;
                    // -------------------------------------
                    // -------------  Current Time:  340ns
                    #100;
                    sw0 = 1'b1;
                    // -------------------------------------
                    // -------------  Current Time:  440ns
                    #100;
                    sw0 = 1'b0;
                    sw1 = 1'b1;
                    // -------------------------------------
                    // -------------  Current Time:  540ns
                    #100;
                    sw1 = 1'b0;
                    sw2 = 1'b1;
                    // -------------------------------------
                    // -------------  Current Time:  640ns
                    #100;
                    sw2 = 1'b0;
                    sw3 = 1'b1;
                    // -------------------------------------
                    // -------------  Current Time:  740ns
                    #100;
                    sw3 = 1'b0;
                    // -------------------------------------
                    // -------------  Current Time:  940ns
                    #200;
                    sw0 = 1'b1;
                    sw1 = 1'b1;
                    // -------------------------------------
                    // -------------  Current Time:  1040ns
                    #100;
                    sw0 = 1'b0;
                    sw2 = 1'b1;
                    // -------------------------------------
                    // -------------  Current Time:  1140ns
                    #100;
                    sw1 = 1'b0;
                    sw3 = 1'b1;
                    // -------------------------------------
                    // -------------  Current Time:  1240ns
                    #100;
                    sw0 = 1'b1;
                    sw2 = 1'b0;
                    // -------------------------------------
                    // -------------  Current Time:  1340ns
                    #100;
                    sw0 = 1'b0;
                    sw3 = 1'b0;
                    // -------------------------------------
                end

                task CHECK_led0;
                    input NEXT_led0;

                    #0 begin
                        if (NEXT_led0 !== led0) begin
                            $display("Error at time=%dns led0=%b, expected=%b", $time, led0, NEXT_led0);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_led1;
                    input NEXT_led1;

                    #0 begin
                        if (NEXT_led1 !== led1) begin
                            $display("Error at time=%dns led1=%b, expected=%b", $time, led1, NEXT_led1);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_led2;
                    input NEXT_led2;

                    #0 begin
                        if (NEXT_led2 !== led2) begin
                            $display("Error at time=%dns led2=%b, expected=%b", $time, led2, NEXT_led2);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_led3;
                    input NEXT_led3;

                    #0 begin
                        if (NEXT_led3 !== led3) begin
                            $display("Error at time=%dns led3=%b, expected=%b", $time, led3, NEXT_led3);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_led4;
                    input NEXT_led4;

                    #0 begin
                        if (NEXT_led4 !== led4) begin
                            $display("Error at time=%dns led4=%b, expected=%b", $time, led4, NEXT_led4);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_led5;
                    input NEXT_led5;

                    #0 begin
                        if (NEXT_led5 !== led5) begin
                            $display("Error at time=%dns led5=%b, expected=%b", $time, led5, NEXT_led5);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_led6;
                    input NEXT_led6;

                    #0 begin
                        if (NEXT_led6 !== led6) begin
                            $display("Error at time=%dns led6=%b, expected=%b", $time, led6, NEXT_led6);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_led7;
                    input NEXT_led7;

                    #0 begin
                        if (NEXT_led7 !== led7) begin
                            $display("Error at time=%dns led7=%b, expected=%b", $time, led7, NEXT_led7);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask

            endmodule

