module assembling_adder(
				clk,rst_n,
				data_in0,data_in1,data_in2,data_in3,
				data_in4,data_in5,data_in6,data_in7,
				data_out
					);
					
	input           clk,rst_n                            ;
	input  [8 :0 ]  data_in0,data_in1,data_in2,data_in3  ;
	input  [8 :0 ]  data_in4,data_in5,data_in6,data_in7  ;
	
	output [11:0 ]  data_out                             ;
	
	wire   [9 :0 ]  data_reg1              [7 :0 ]       ;
	reg    [9 :0 ]  data_reg2              [3 :0 ]       ;
	wire   [10:0 ]  data_reg3              [3 :0 ]       ;
	reg    [10:0 ]  data_reg4              [1 :0 ]       ;
	wire   [11:0 ]  data_reg5              [1 :0 ]       ;
	reg    [11:0 ]  data_reg6                            ;
	wire   [11:0 ]  data_out                             ;
	
	//assign data_reg1[0] = (~data_in0) + 9'b0_0000_0001 ;
	//assign data_reg1[1] = (~data_in1) + 9'b0_0000_0001 ;
	//assign data_reg1[2] = (~data_in2) + 9'b0_0000_0001 ;
	//assign data_reg1[3] = (~data_in3) + 9'b0_0000_0001 ;
	//assign data_reg1[4] = (~data_in4) + 9'b0_0000_0001 ;
	//assign data_reg1[5] = (~data_in5) + 9'b0_0000_0001 ;
	//assign data_reg1[6] = (~data_in6) + 9'b0_0000_0001 ;
	//assign data_reg1[7] = (~data_in7) + 9'b0_0000_0001 ;
	//
	//assign data_out = (~data_reg4) + 12'b0000_0000_0001 ;
	
	assign data_reg1[0] = {data_in0[8],data_in0} ;
	assign data_reg1[1] = {data_in1[8],data_in1} ;
	assign data_reg1[2] = {data_in2[8],data_in2} ;
	assign data_reg1[3] = {data_in3[8],data_in3} ;
	assign data_reg1[4] = {data_in4[8],data_in4} ;
	assign data_reg1[5] = {data_in5[8],data_in5} ;
	assign data_reg1[6] = {data_in6[8],data_in6} ;
	assign data_reg1[7] = {data_in7[8],data_in7} ;
	      
	assign data_out = data_reg6 ;
	
	always @ ( posedge clk or negedge rst_n )
		if( !rst_n )
			begin
				data_reg2[0] <= 10'b00_0000_0000 ;
				data_reg2[1] <= 10'b00_0000_0000 ;
				data_reg2[2] <= 10'b00_0000_0000 ;
				data_reg2[3] <= 10'b00_0000_0000 ;
			end
		else
			begin
				data_reg2[0] <= data_reg1[0] + data_reg1[1] ;
				data_reg2[1] <= data_reg1[2] + data_reg1[3] ;
				data_reg2[2] <= data_reg1[4] + data_reg1[5] ;
				data_reg2[3] <= data_reg1[6] + data_reg1[7] ;
			end
			
	assign data_reg3[0] = {data_reg2[0][9],data_reg2[0]} ;
	assign data_reg3[1] = {data_reg2[1][9],data_reg2[1]} ;
	assign data_reg3[2] = {data_reg2[2][9],data_reg2[2]} ;
	assign data_reg3[3] = {data_reg2[3][9],data_reg2[3]} ;
			
	always @ ( posedge clk or negedge rst_n )
		if( !rst_n )
			begin
				data_reg4[0] <= 11'b000_0000_0000 ;
				data_reg4[1] <= 11'b000_0000_0000 ;
			end
		else
			begin
				data_reg4[0] <= data_reg3[0] + data_reg3[1] ;
				data_reg4[1] <= data_reg3[2] + data_reg3[3] ;
			end
			
	assign data_reg5[0] = {data_reg4[0][10],data_reg4[0]} ;
	assign data_reg5[1] = {data_reg4[1][10],data_reg4[1]} ;
			
	always @ ( posedge clk or negedge rst_n )
		if( !rst_n )
			begin
				data_reg6 <= 12'b0000_0000_0000 ;
			end
		else
			begin
				data_reg6 <= data_reg5[0] + data_reg5[1] ;
			end
			
endmodule

module test;
	
	reg           clk,rst_n                            ;				
	reg  [8 :0 ]  data_in0,data_in1,data_in2,data_in3  ;
	reg  [8 :0 ]  data_in4,data_in5,data_in6,data_in7  ;
	                                                      
	wire [11:0 ]  data_out                             ;
	
initial 
	begin
		clk=0;
		rst_n=1;
		data_in0=9'b0_0000_0000;
		data_in1=9'b0_0000_0000;
		data_in2=9'b0_0000_0000;
		data_in3=9'b0_0000_0000;
		data_in4=9'b0_0000_0000;
		data_in5=9'b0_0000_0000;
		data_in6=9'b0_0000_0000;
		data_in7=9'b0_0000_0000;
		#100 rst_n=0;
		#100 rst_n=1;
		data_in0=9'b1_0011_0000;
		data_in1=9'b0_0000_0010;
		data_in2=9'b1_0110_0000;
		data_in3=9'b0_0001_0010;
		data_in4=9'b1_0011_0000;
		data_in5=9'b0_0011_1100;
		data_in6=9'b1_0100_0001;
		data_in7=9'b0_1100_0001;
		#100 data_in0=9'b1_111_0010;
		data_in1=9'b0_0011_0110;
		data_in2=9'b0_0000_0000;
		data_in3=9'b0_0001_0000;
		data_in4=9'b0_0000_0000;
		data_in5=9'b0_0000_0110;
		data_in6=9'b0_0110_0000;
		data_in7=9'b1_0111_0111;
		#100 data_in0=9'b0_1111_0000;
		data_in1=9'b0_1111_0000;
		data_in2=9'b1_1111_0000;
		data_in3=9'b0_0011_0000;
		data_in4=9'b1_0110_0111;
		data_in5=9'b1_1110_0000;
		data_in6=9'b1_1110_0000;
		data_in7=9'b0_0000_0111;
		#1000 $stop;
	end
	always #50 clk = ~clk ;
	assembling_adder adder(
				.clk(clk),
				.rst_n(rst_n),
				.data_in0(data_in0),
				.data_in1(data_in1),
				.data_in2(data_in2),
				.data_in3(data_in3),
				.data_in4(data_in4),
				.data_in5(data_in5),
				.data_in6(data_in6),
				.data_in7(data_in7),
				.data_out(data_out)
					);	
					
endmodule	
	
		
		