module change1_8(
		clk,rst_n,
		data_in,
		data_out
			);
			
	input             clk,rst_n       ;
	input   [7 :0 ]   data_in         ;
	
	output            data_out        ;
	
	wire              data_out        ;
	reg     [2 :0 ]   cnt             ;
	reg     [7 :0 ]   data_reg        ;

	assign  data_out = data_reg[cnt]  ;
	
always @ ( posedge clk or negedge rst_n )
	if( !rst_n )
		cnt <= 3'b000 ;
	else
		begin
			if( 3'b000 == cnt )
				begin
					cnt<=3'b111 ;
					data_reg <= data_in ;
				end
			else
				cnt <= cnt - 3'b001 ;
		end
		
endmodule

module test;

	reg             clk,rst_n       ;
	reg   [7 :0 ]   data_in         ;
	
	wire            data_out        ;
	
initial
	begin
		clk=0;
		rst_n=1;
		data_in=8'b0000_0000;
		#100 rst_n=0;
		#100 rst_n=1;
		data_in=8'b1001_0101;
		#800 data_in=8'b0110_1010;
		#1000 $stop;
	end
always #50 clk=~clk;
change1_8 change(
		.clk(clk),.rst_n(rst_n),
		.data_in(data_in),
		.data_out(data_out)
			);
endmodule	