module fifo8_128(clk,rst_n,data_in,data_out);

	input              clk,rst_n             ;
	input  [7 :0 ]     data_in               ;
	
	output [7 :0 ]     data_out              ;
	
	reg    [7 :0 ]     data_reg     [127:0 ] ;
	reg    [7 :0 ]     data_out              ;
	
	reg    [6 :0 ]     i                     ;
	
always @ ( posedge clk or negedge rst_n )
	if( !rst_n )
		data_out <= 8'b0000_0000 ;
	else
		begin
			data_reg[0] <= data_in ;
			data_out <= data_reg[127] ;
			for(i=0;i<127;i=i+1)
				data_reg[i+1] <= data_reg[i] ;
		end

endmodule

module test;

	reg              clk,rst_n             ;
	reg  [7 :0 ]     data_in               ;
	
	wire [7 :0 ]     data_out              ;
	
initial
	begin
		clk=0;
		rst_n=1;
		data_in=8'b0000_0000;
		#100 rst_n=0;
		#100 rst_n=1;
	end
	always #50 clk=~clk;
	always #100 data_in=data_in+8'b0000_0001;
fifo8_128 fifo(
			.clk(clk),
			.rst_n(rst_n),
			.data_in(data_in),
			.data_out(data_out)
				);
				
endmodule