module adder(clk,rst_n,data_in,data_out);

	input               clk,rst_n            ;
	input  [31:0 ]      data_in              ;
	
	output [9 :0 ]      data_out             ;
	
	reg    [8 :0 ]      data_reg   [1 :0 ]   ;
	reg    [9 :0 ]      data_out             ;
	
always @ ( posedge clk or negedge rst_n )
	if( !rst_n )
		begin
			data_reg[0] <= 9'b0 ;
			data_reg[1] <= 9'b0 ;
		end
	else
		begin
			data_reg[0] <= {data_in[7],data_in[7:0]} + {data_in[15],data_in[15:8]} ;
			data_reg[1] <= {data_in[23],data_in[23:16]} + {data_in[31],data_in[31:24]} ;
		end
		
always @ ( posedge clk or negedge rst_n )
	if( !rst_n )
		data_out <= 10'b0 ;
	else
		data_out <= {data_reg[1][8],data_reg[1]} + {data_reg[0][8],data_reg[0]} ;
		
endmodule        