module IIR(clk,rst_n,din,dout);

	input                   clk,rst_n            ;
	input    [12:0 ]        din                  ;
                                               
	output   [12:0 ]        dout                 ;
	                                             
	reg      [12:0 ]        x1,x2,x3             ;
	reg      [12:0 ]        y1,y2,y3             ;
	reg      [12:0 ]        q1,q2,q3             ;
	reg      [12:0 ]        dout                 ;
	
	wire     [25:0 ]        sum1_abuf,sum2_abuf  ;
	wire     [12:0 ]        sum1_buf,sum2_buf    ;
	wire     [25:0 ]        mul         [10:1 ]  ;

always @ ( posedge clk or negedge rst_n )
	if( !rst_n )
		begin
			x1 <= 13'b0 ;  y1 <= 13'b0 ;  q1 <= 13'b0 ;
			x2 <= 13'b0 ;  y2 <= 13'b0 ;  q2 <= 13'b0 ;
			x3 <= 13'b0 ;  y3 <= 13'b0 ;  q3 <= 13'b0 ;
		end
	else
		begin
			x3 <= x2 ; x2 <= x1 ; x1 <= din      ;
			y3 <= y2 ; y2 <= y1 ; y1 <= sum1_buf ;
			q3 <= q2 ; q2 <= q1 ; q1 <= sum2_buf ;
		end
		
always @ ( posedge clk or negedge rst_n )
	if( !rst_n )
		dout <= 13'b0 ;
	else
		dout <= q1 ;
		
//assign   sum1_abuf  =  mul[1] + mul[2] + mul[3] + mul[4] + mul[5]  ;
//assign   sum2_abuf  =  mul[6] + mul[7] + mul[8] + mul[9] + mul[10] ;

assign   sum1_abuf  =  mul[1] + mul[5]  ;
assign   sum2_abuf  =  mul[6] + mul[10] ;
  

assign   sum1_buf   =  sum1_abuf[25:13]  ;
assign   sum2_buf   =  sum2_abuf[25:13]  ;

multiply m0 ( .clk(clk),.a(x1),.o(mul[1] ) );
multiply m1 ( .clk(clk),.a(x2),.o(mul[2] ) ); 
multiply m2 ( .clk(clk),.a(x3),.o(mul[3] ) ); 
multiply m3 ( .clk(clk),.a(y1),.o(mul[4] ) ); 
multiply m4 ( .clk(clk),.a(y2),.o(mul[5] ) ); 
multiply m5 ( .clk(clk),.a(y1),.o(mul[6] ) ); 
multiply m6 ( .clk(clk),.a(y2),.o(mul[7] ) ); 
multiply m7 ( .clk(clk),.a(y3),.o(mul[8] ) ); 
multiply m8 ( .clk(clk),.a(q1),.o(mul[9] ) ); 
multiply m9 ( .clk(clk),.a(q2),.o(mul[10]) ); 
			 
endmodule