`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    09:26:17 10/11/06
// Design Name:    
// Module Name:    state_machine
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module state_machine(clk,rst_n,
		dout0,dout1,dout2,dout3,dout4,dout5,dout6,dout7
					);

	input         clk,rst_n ;
	
	output        dout0,dout1,dout2,dout3,dout4,dout5,dout6,dout7 ;

	parameter     STATE0	 =	 3'b000  ,
					  STATE1  =	 3'b001  ,
					  STATE2	 =	 3'b010  ,
					  STATE3	 =	 3'b011  ,
					  STATE4	 =	 3'b100  ,
					  STATE5	 =	 3'b101  ,
					  STATE6	 =	 3'b110  , 
					  STATE7	 =	 3'b111  ;

	wire          dout0,dout1,dout2,dout3,dout4,dout5,dout6,dout7 ;
	reg   [7 :0 ] data ;
	reg   [23:0 ] cnt ;
	reg   [2 :0 ] state ;

	wire          clk_slow ;

	assign        {dout7,dout6,dout5,dout4,dout3,dout2,dout1,dout0} = data ;
	assign        clk_slow = cnt[23] ;

	always @ ( posedge clk or negedge rst_n )
		if( !rst_n )
			cnt<=24'b0000_0000_0000_0000_0000_0000;
		else
			cnt<=cnt+24'b0000_0000_0000_0000_0000_0001;

	always @ ( posedge clk_slow or negedge rst_n )
		if( !rst_n )
			state<=STATE0;
		else
			case( state )
				STATE0:state<=STATE1;
				STATE1:state<=STATE2;
				STATE2:state<=STATE3;
				STATE3:state<=STATE4;
				STATE4:state<=STATE5;
				STATE5:state<=STATE6;
				STATE6:state<=STATE7;	
				STATE7:state<=STATE0;
				default:state<=STATE0;
			endcase

	always @ ( posedge clk_slow or negedge rst_n )
		if( !rst_n )
			data<=8'b0000_0000;
		else
			case( state )
				STATE0:data<=8'b0000_0001;
				STATE1:data<=8'b0000_0010;
				STATE2:data<=8'b0000_0100;
				STATE3:data<=8'b0000_1000;
				STATE4:data<=8'b0001_0000;
				STATE5:data<=8'b0010_0000;
				STATE6:data<=8'b0100_0000;	
				STATE7:data<=8'b1000_0000;
				default:data<=8'b0000_0000;
			endcase

endmodule
