`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    12:45:04 10/11/06
// Design Name:    
// Module Name:    7seg
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module seg_led(clk,rst,
			s0,s1,s2,s3,
			d0,d1,d2,d3,d4,d5,d6,d7
			);

	input      clk,rst       ;
	output     s0,s1,s2,s3   ;
	output     d0,d1,d2,d3,d4,d5,d6,d7 ;

	reg [1 :0 ] state ;
	reg [3 :0 ] sn ;
	reg [7 :0 ] data ;
	reg [15:0 ] cnt ;
	
	wire       s0,s1,s2,s3   ;
	wire       d0,d1,d2,d3,d4,d5,d6,d7 ; 

	assign     {s3,s2,s1,s0} = sn ;
	assign     {d7,d6,d5,d4,d3,d2,d1,d0} = data ;

	always @ ( posedge clk )
		if( !rst )
			cnt<=16'b0;
		else
			cnt<=cnt+16'b1;

	wire clk_slow = cnt[15] ;

	always @ ( posedge clk_slow or negedge rst )
		if( !rst )
			state<=2'b00;
		else
			state<=state+2'b01;

	always @ ( posedge clk_slow or negedge rst )
		if( !rst )
			begin
				sn<=4'b0;
				data<=8'b0;
			end
		else
			case(state)
				2'b00:
					begin
						sn<=4'b0001;
						data<=8'b0110_0000;
					end
				2'b01:
					begin
						sn<=4'b0010;
						data<=8'b1101_1010;
					end
				2'b10:
					begin
						sn<=4'b0100;
						data<=8'b1111_0010;
					end
				2'b11:
					begin
						sn<=4'b1000;
						data<=8'b0110_0110;
					end
			endcase


endmodule
