////////////////////////////////////////////////////////////////////////////////
// Copyright (c) 1995-2003 Xilinx, Inc.
// All Right Reserved.
////////////////////////////////////////////////////////////////////////////////
//   ____  ____ 
//  /   /\/   / 
// /___/  \  /    Vendor: Xilinx 
// \   \   \/     Version : 7.1i
//  \   \         Application : ISE Foundation
//  /   /         Filename : test.tfw
// /___/   /\     Timestamp : Thu Oct 19 14:33:24 2006
// \   \  /  \ 
//  \___\/\___\ 
//
//Command: 
//Design Name: test
//Device: Xilinx
//
`timescale 1ns/1ps

module test;
    reg clk = 1'b0;
    reg rst_n = 1'b1;
    wire seg_en0;
    wire seg_en1;
    wire seg_en2;
    wire seg_en3;
    wire data0;
    wire data1;
    wire data2;
    wire data3;
    wire data4;
    wire data5;
    wire data6;
    wire data7;

    parameter PERIOD = 100;
    parameter real DUTY_CYCLE = 0.5;
    parameter OFFSET = 0;

    initial    // Clock process for clk
    begin
        #OFFSET;
        forever
        begin
            clk = 1'b0;
            #(PERIOD-(PERIOD*DUTY_CYCLE)) clk = 1'b1;
            #(PERIOD*DUTY_CYCLE);
        end
    end

    counter UUT (
        .clk(clk),
        .rst_n(rst_n),
        .seg_en0(seg_en0),
        .seg_en1(seg_en1),
        .seg_en2(seg_en2),
        .seg_en3(seg_en3),
        .data0(data0),
        .data1(data1),
        .data2(data2),
        .data3(data3),
        .data4(data4),
        .data5(data5),
        .data6(data6),
        .data7(data7));

        integer TX_ERROR = 0;
        
        initial begin  // Open the results file...
            #3100 // Final time:  3100 ns
            if (TX_ERROR == 0) begin
                $display("No errors or warnings.");
                end else begin
                    $display("%d errors found in simulation.", TX_ERROR);
                    end
                    $stop;
                end

                initial begin
                    // -------------  Current Time:  41ns
                    #41;
                    rst_n = 1'b0;
                    // -------------------------------------
                    // -------------  Current Time:  141ns
                    #100;
                    rst_n = 1'b1;
                    // -------------------------------------
                end

                task CHECK_seg_en0;
                    input NEXT_seg_en0;

                    #0 begin
                        if (NEXT_seg_en0 !== seg_en0) begin
                            $display("Error at time=%dns seg_en0=%b, expected=%b", $time, seg_en0, NEXT_seg_en0);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_seg_en1;
                    input NEXT_seg_en1;

                    #0 begin
                        if (NEXT_seg_en1 !== seg_en1) begin
                            $display("Error at time=%dns seg_en1=%b, expected=%b", $time, seg_en1, NEXT_seg_en1);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_seg_en2;
                    input NEXT_seg_en2;

                    #0 begin
                        if (NEXT_seg_en2 !== seg_en2) begin
                            $display("Error at time=%dns seg_en2=%b, expected=%b", $time, seg_en2, NEXT_seg_en2);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_seg_en3;
                    input NEXT_seg_en3;

                    #0 begin
                        if (NEXT_seg_en3 !== seg_en3) begin
                            $display("Error at time=%dns seg_en3=%b, expected=%b", $time, seg_en3, NEXT_seg_en3);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_data0;
                    input NEXT_data0;

                    #0 begin
                        if (NEXT_data0 !== data0) begin
                            $display("Error at time=%dns data0=%b, expected=%b", $time, data0, NEXT_data0);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_data1;
                    input NEXT_data1;

                    #0 begin
                        if (NEXT_data1 !== data1) begin
                            $display("Error at time=%dns data1=%b, expected=%b", $time, data1, NEXT_data1);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_data2;
                    input NEXT_data2;

                    #0 begin
                        if (NEXT_data2 !== data2) begin
                            $display("Error at time=%dns data2=%b, expected=%b", $time, data2, NEXT_data2);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_data3;
                    input NEXT_data3;

                    #0 begin
                        if (NEXT_data3 !== data3) begin
                            $display("Error at time=%dns data3=%b, expected=%b", $time, data3, NEXT_data3);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_data4;
                    input NEXT_data4;

                    #0 begin
                        if (NEXT_data4 !== data4) begin
                            $display("Error at time=%dns data4=%b, expected=%b", $time, data4, NEXT_data4);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_data5;
                    input NEXT_data5;

                    #0 begin
                        if (NEXT_data5 !== data5) begin
                            $display("Error at time=%dns data5=%b, expected=%b", $time, data5, NEXT_data5);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_data6;
                    input NEXT_data6;

                    #0 begin
                        if (NEXT_data6 !== data6) begin
                            $display("Error at time=%dns data6=%b, expected=%b", $time, data6, NEXT_data6);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask
                task CHECK_data7;
                    input NEXT_data7;

                    #0 begin
                        if (NEXT_data7 !== data7) begin
                            $display("Error at time=%dns data7=%b, expected=%b", $time, data7, NEXT_data7);
                            TX_ERROR = TX_ERROR + 1;
                        end
                    end
                endtask

            endmodule

