`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:    23:38:41 04/19/06
// Design Name:    
// Module Name:    top
// Project Name:   
// Target Device:  
// Tool versions:  
// Description:
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module top(sp,    
	
	led,
  	clk,
	rst_n);

output	        sp;

output  [2:0]   led;
input	        clk;
input	        rst_n; // synthesis attribute clock_buffer of rst_n is ibufg;

reg     [23:0]   clk_cnt;
  always @ ( posedge clk or negedge rst_n)
    if (!rst_n )
        clk_cnt <= 24'd0;
    else
        clk_cnt <= clk_cnt + 1'b1;

  wire  clk_6mhz = (clk_cnt[2]||(clk_cnt[1]&&clk_cnt[0]));                        //(clk_cnt[2]&&clk_cnt[1]);
  wire  clk_4hz  = (clk_cnt[22]&&clk_cnt[23]);
      
wire    [3:0]   high,med,low;      




  assign    led[0] = |{high,med,low};
  assign    led[1] = |{high,med};
  assign    led[2] = |high;
song song_inst
    (
    .clk_6mhz   (clk_6mhz), 
    .clk_4hz    (clk_4hz),
    .sp         ( sp    ),
    .high       ( high  ),
    .med        ( med   ),
    .low        ( low   )
    );



endmodule
