library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;



entity lcd is
    Port ( clk : in std_logic;				 --50Mhz/16=3.125Mhz
           Reset : in std_logic;
           lcd_rs : out std_logic;
           lcd_rw : out std_logic;
		   lcd_e  : buffer std_logic;
		   data : out std_logic_vector(7 downto 0);
		   stateout: out std_logic_vector(10 downto 0)
		   );
end lcd;


architecture Behavioral of lcd is

constant IDLE :         std_logic_vector(10 downto 0) :="00000000000";
constant CLEAR :        std_logic_vector(10 downto 0) :="00000000001";
constant RETURNCURSOR : std_logic_vector(10 downto 0) :="00000000010" ;
constant SETMODE      : std_logic_vector(10 downto 0) :="00000000100";
constant SWITCHMODE   : std_logic_vector(10 downto 0) :="00000001000";
constant SHIFT        : std_logic_vector(10 downto 0) :="00000010000";
constant SETFUNCTION  : std_logic_vector(10 downto 0) :="00000100000";
constant SETCGRAM     : std_logic_vector(10 downto 0) :="00001000000";
constant SETDDRAM     : std_logic_vector(10 downto 0) :="00010000000";
constant READFLAG     : std_logic_vector(10 downto 0) :="00100000000";
constant WRITERAM     : std_logic_vector(10 downto 0) :="01000000000";
constant READRAM      : std_logic_vector(10 downto 0) :="10000000000";




constant cur_inc      : std_logic :='1'; --1/Dָʾƶ,ߵƽ,͵ƽ
constant cur_dec      : std_logic :='0';
constant cur_shift    : std_logic :='1'; --SָʾĻ,Ƿƻ,ߵƽЧ
constant cur_noshift  : std_logic :='0'; 
constant open_display : std_logic :='1'; --DʾĿ,ߵƽʾʾ,Ϊʾ
constant open_cur     : std_logic :='0'; --CƹĿ,ߵƽʾй
constant blank_cur    : std_logic :='0'; --BƹǷ˸,ߵƽ˸
constant shift_display: std_logic :='1'; --S/C Ƿƶʾֻ,ߵƽΪƶ,͵ƽΪƶ
constant shift_cur    : std_logic :='0'; 
constant right_shift  : std_logic :='1'; --R/L ֻƶ,ߵƽΪ,͵ƽΪ
constant left_shift   : std_logic :='0';
constant datawidth8   : std_logic :='1'; --DL λΪ8λ
constant datawidth4   : std_logic :='0'; --DL ߱Ϊ4λ
constant twoline      : std_logic :='1'; --N ߵƽʱΪ˫ʾ,͵ƽΪʾ
constant oneline      : std_logic :='0';
constant font5x10     : std_logic :='1'; --F ߵƽʱΪ5*10ַ
constant font5x7      : std_logic :='0'; --F ͵ƽʱΪ5*7

signal state : std_logic_vector(10 downto 0);
signal counter : integer range 0 to 127;
signal div_counter : integer range 0 to 15;
signal flag        : std_logic;
constant DIVSS : integer :=15;

signal char_addr : std_logic_vector(5 downto 0);
signal data_in   : std_logic_vector(7 downto 0);
component char_ram
          port( address : in std_logic_vector(5 downto 0) ;
	             data    : out std_logic_vector(7 downto 0)
		         );
end component;--ģ


signal clk_int: std_logic; --Ϊ2*51.2us=102.4us

signal clkcnt: std_logic_vector(15 downto 0);
constant divcnt: std_logic_vector(15 downto 0):="1001110001000000"; --40000
signal clkdiv: std_logic; --Ϊ2*25.6us=51.2us
signal tc_clkcnt: std_logic; --Ϊ20*16ns*80000=25.6us 
begin


process(clk,reset)
begin
  if(reset='0')then
  clkcnt<="0000000000000000";
  elsif(clk'event and clk='1')then
     if(clkcnt=divcnt)then
     clkcnt<="0000000000000000";
     else
     clkcnt<=clkcnt+1;
     end if;
  end if;
end process;
tc_clkcnt<='1' when clkcnt=divcnt else
           '0';

process(tc_clkcnt,reset)
begin
   if(reset='0')then
   clkdiv<='0';
   elsif(tc_clkcnt'event and tc_clkcnt='1')then
   clkdiv<=not clkdiv;
   end if;
end process;

process(clkdiv,reset)
begin
  if(reset='0')then
    clk_int<='0';
  elsif(clkdiv'event and clkdiv='1')then
    clk_int<= not clk_int;
  end if;
end process;

process(clkdiv,reset) --ȡ½,lcd_eclk_inӳٰʱ,ʱҪ
begin
   if(reset='0')then
     lcd_e<='0';
   elsif(clkdiv'event and clkdiv='0')then
     lcd_e<= not lcd_e;
   end if;
end process;

aa:char_ram
   port map( address=>char_addr,data=>data_in);

    lcd_rs <= '1' when state =WRITERAM or state = READRAM else '0'; --rsΪĴѡ,ߵƽѡݼĴ,ΪָĴ
	lcd_rw <= '0' when state =CLEAR or state = RETURNCURSOR or state=SETMODE or state=SWITCHMODE or state=SHIFT or state= SETFUNCTION or state=SETCGRAM or state =SETDDRAM or state =WRITERAM else
	          '1'; --rwΪдź,ߵƽж,͵ƽд
     data <=    "00000001" when state =CLEAR else --ʾ:ָ0000_0001
	           "00000010" when state =RETURNCURSOR else  --긴λ:ָ0000_0010ڹ귵
			 "000001"& cur_inc & cur_noshift  when state = SETMODE else --ʾģʽ:ָʾ,ֲƶ
			 "00001" & open_display &open_cur & blank_cur when state =SWITCHMODE else--ʾؿ:ʾ,޹,˸
			 "0001" & shift_display &left_shift &"00" when state = SHIFT else --ʾλ:ƶ
			 "001" & datawidth8 & twoline &font5x10 & "00" when state=SETFUNCTION else  --:λΪ8,˫ʾ,5*10
			 "01000000" when state =SETCGRAM else --ַַ
			 "10000000" when state =SETDDRAM and counter =0 else --ݴ洢ַ,λΪ1,λΪDRAMĵʼַ
			 "11000000" when state =SETDDRAM and counter /=0 else --õڶʾʼַ
			  data_in when state = WRITERAM else
			 "ZZZZZZZZ";

   char_addr  <=conv_std_logic_vector( counter,6) when state =WRITERAM and counter<40 else --counterΪַ,ѡҪַ,char_ramģ,ӦַCGROM(ַ洢)еĵַ
	            conv_std_logic_vector( counter-41+8,6) when state= WRITERAM and counter>40 and counter<81-8 else --+8ΪõڶдRʼʾ,ΪRedlogic World!
			    conv_std_logic_vector( counter-81+8,6) when state= WRITERAM and counter>81-8 and counter<81 else 
				"000000";
						
						
  stateout<=state;
--״̬,ʱ߼,״̬ת
  process(clk_int,Reset) --ʱԼΪ100us
  begin
      if(Reset='0')then 
		   state<=IDLE;
		   counter<=0;
		   flag<='0';
           div_counter<=0;
      elsif(clk_int'event and clk_int='1')then 
		   case state is
			when IDLE =>
			        if(flag='0')then 
						     state<=SETFUNCTION; --빦״̬
							 flag<='1';
							 counter<=0;
							 div_counter<=0;
                    else
						 if(div_counter<DIVSS )then
							 div_counter<=div_counter +1;
                             state<=IDLE;
                         else
							 div_counter<=0;
							 state <=SHIFT;
                         end if;
                    end if;
         when CLEAR    => --
			           state<=SETMODE;
         when SETMODE  => --ʾģʽ
			          -- state<=WRITERAM;
					   state <= SETDDRAM;  --counter=0ʱ,ʾĵһеĵַ
         when RETURNCURSOR => --긴λ,ģûõ
			           state<=WRITERAM;
         when SWITCHMODE => --ʾؿ
			           state<=CLEAR;
         when SHIFT      =>
			           state<=IDLE;
         when SETFUNCTION => --
			           state<=SWITCHMODE;
         when SETCGRAM   =>
			           state<=IDLE;
         when SETDDRAM   => --DRAM
			           state<=WRITERAM;
         when READFLAG   =>
			           state<=IDLE;
         when WRITERAM   => 
			           if(counter =40)then --ʾ"Welecome Redlogi"(һֻʾ16ַ),ͣһʱ
						     state<=SETDDRAM; --ʾһк,ҪDRAMַ,ʾڶ
							 counter<=counter+1;
                        elsif(counter/=40 and counter<81)then --ʾ"Redlogic World!"
						     state<=WRITERAM;
							 counter<=counter+1;
                        else
						    state<=SHIFT;
                    end if;
         when READRAM => --ȡDRAMеֵ,ģûõ
			           state<=IDLE;
         when others  =>
			           state<=IDLE;
         end case;
    end if;
  end process;

  
end Behavioral;
